;   PER ACAD 12 o superiore    I T A L I A N O / I N G L E S E
;
;	by c. Rivoira 2005
;
;      _________________________________________________________________
;									
;         Vengono analizzate tutte le quote di un disegno:		
;									
;         Le quote a cui  stato modificato il testo			
;         (es. per "forzare" una quota non in scala corretta),		
;         vengono SOTTOLINEATE.						
;									
;         E' stato inserito uno specifico controllo per impedire	
;         l'aggiunta del codice di sottolineatura (%%u) alle quote	
;         che lo hanno gi ricevuto in precedenza (mettere 2 volte %%u	
;	  annulla la sottolineatura che per quelle quote  necessaria)	
;									
;	________________________________________________________________
;
;	Le quote evidenziate per la prima volta vengono indicate da una linea rossa; se poi si creano
;	nuove quote "Forzate" e si rilancia il comando con l'opzione +, le precedenti saranno bianche,
;	mentre le nuove saranno rosse.
;
;
;	28-02-05	Le quote vengono evidenz. con "+" e tornano normali con "-"
;	20-03-05	Introdotta "lineset": usata per cancel. le linee (non diventa nil in uscita)
;
;
;---------------------------------
;  Input Variabili ambiente
;---------------------------------
(defun MODES (a)
   (setq mlst '())
   (repeat (length a)
      (setq mlst (append mlst (list (list (car a) (getvar (car a))))))
      (setq a (cdr a))
   )
)
;-----------------------------------
;  Ripristina variabili ambiente
;-----------------------------------
(defun MODER ()
   (repeat (length mlst)
      (setvar (caar mlst) (cadar mlst))
      (setq mlst (cdr mlst))
   )
)
; ----------------------------------
; Error handler (gestione errore)
; ----------------------------------
(defun b_err (st)
  (moder)				; Ripristina variabili memorizzate
  (setq *error* olderr)			; Restore old *error* handler

;;;;  Inserire qui altre variabili di sistema o comandi da eseguire prima dell'uscita

  (princ)				; Esce senza nil
)

;-------------------------------
;     	  INPUT DATI		
;-------------------------------
(defun indati ()
   (graphscr)
   (setvar "highlight" 1)
   (modes '("HIGHLIGHT" "LIMCHECK" "CMDECHO" "OSMODE"))
   (setvar "limcheck" 0)
   (setvar "cmdecho" 0)
   (setvar "osmode" 0)   
;
   (setq primav T)			; Inizializza il flag per la richiesta di un "click" su una zona del disegno
;
   (initget "+ -")
   (setq cosa(getkword "\n+ per evidenziare le quote - per tornare normale? <+> "))
   (if (= cosa nil)(setq cosa "+"))	; Default = +
;
   (if lineset
     (progn
       (command "_erase" lineset "")	; Se esiste set delle linee (da comando precedente) le elimina
       (setq lineset nil)		; Annulla il set di selezione: le linee non esistono pi
     )
   )
;
(if (= cosa "+")
					; ------  INIZIO SOTTOLINEATURA QUOTE ------
 (progn   
   (setq ent (ssget "X" '((0 . "DIMENSION"))))		; Seleziona le quote di tutto il disegno
   (setq num (sslength ent))		; Numero entita selezionate
   (setq indice 0)			; Inizializza l'indice
   (repeat num
     (setq nome (ssname ent indice))	; Nome entita' esadecimale
     (setq lst (entget nome))		; Singola entita'
     (setq txt (cdr (assoc 1 lst)))	; Estrae tipo di entit
     (if (/= txt "")			; Se il testo di quota non  quello di default ...
        (parti txt)			; ... verifica se ha comunque la stringa "<>" all'interno
        (setq flag nil)			; ... se invece  gi quello di default annulla il flag
     )
     (if flag				; Se il testo di quota non  quello di default (flag = T)...
       (progn
         (if primav			; se  la prima volta che passa di qui ...
	   (progn			; ... Chiede di cliccare in una zona vuota del disegno.
	      (click)			; Salta alla sub di richiesta punto
	      (setq primav nil)		; Annulla il flag (per non passarci un'altra volta)
	   )
         )				; Fine di primav
;
	 (if (/= (substr txt 1 3) "%%u") ; Se il testo non era gi stato evidenziato in precedenza ...
	   (progn
             (setq txt1 (strcat "%%u" txt)); Lo sottolinea per evidenziarlo
	     (setq pt2 (cdr (assoc 11 lst))); Estrae coord. testo di quota variato
	     (command "_line" pt1 (trans pt2 0 1) ""); Traccia linea (trasforma pt2 da UCS a WCS)
             (command "_change" (entlast) "" "_P" "_c" 1 ""); la linea diventa rossa
	   )
           (progn
	     (setq txt1 txt)		; ... altrimenti non lo varia (ha gi %%u davanti)
	     (setq pt2 (cdr (assoc 11 lst))); Estrae coord. testo di quota
	     (command "_line" pt1 (trans pt2 0 1) ""); Traccia linea (trasforma pt2 da UCS a WCS)
             (command "_change" (entlast) "" "_P" "_c" 7 ""); la linea diventa bianca
           )
	 )				; Fine di (if (/= (substr txt 1 3) "%%u")
	 				;
         (if lineset			; Se esiste gi il set di selezione ...
	    (setq lineset (ssadd (entlast) lineset)); Aggiunge al set preesistente
	    (setq lineset (ssadd (entlast))); ... altrimenti crea il set con ultima entit
	 )
	 				;
	 (setq lst1 (subst (cons 1 txt1) (cons 1 txt) lst)); Sostituisce il vecchio con il nuovo
	 (entmod lst1)			; Rende operativa la modifica
       )
     )
     (setq indice (+ indice 1))		; Incrementa l'indice
   )
 )					; Fine di progn
;
;
					; -------  INIZIO DESOTTOLINEATURA QUOTE ------
 (progn
   (setq ent (ssget "X" '((0 . "DIMENSION"))))	; Seleziona le quote di tutto il disegno
   (setq num (sslength ent))		; Numero entita selezionate
   (setq indice 0)			; Inizializza l'indice
   (repeat num
     (setq nome (ssname ent indice))	; Nome entita' esadecimale
     (setq lst (entget nome))		; Singola entita'
     (setq txt (cdr (assoc 1 lst)))	; Estrae tipo di entit
     (if (/= txt "")			; Se il testo di quota non  quello di default ...
        (parti txt)			; ... verifica se ha comunque la stringa "<>" all'interno
        (setq flag nil)			; ... se invece  gi quello di default annulla il flag
     )
     (if flag
        (progn
          (setq txt1 (substr txt 4))	; TXT1 = a TXT dal quarto carattere in poi (toglie %%u davanti)
          (setq flag nil)		; Annulla il flag (per il prossimo elemento)
	  (setq lst1 (subst (cons 1 txt1) (cons 1 txt) lst)); Sostituisce il vecchio con il nuovo
	  (entmod lst1)			; Rende operativa la modifica
        )
     )					; Fine di if flag
     (setq indice (+ indice 1))		; Incrementa l'indice
   )					; Fine di repeat num
   (setq primav nil)			; flag a nil (evita il msg "NON CI SONO QUOTE DA EVIDENZIARE" in uscita)
 )					; Fine di progn

)					; Fine di (= cosa "+")

)					; Fine di INDATI
;
;

;--------------------------------------
;    Richiede un punto sullo schermo
;--------------------------------------
;
; Viene usato un "while" per continuare a richiedere il punto finch si otterr un punto valido (non un Invio)
; E' stato messo in una subrutine poich non  possibile effettuare un comando while all'interno di un IF.
;
(defun click ()
  (while (= pt1 nil)
    (setq pt1 (getpoint "\nClicca in una zona vuota del disegno ... "))
  )
)
;
;------------------------------------------------------------------------
;    Cerca la stringa "<>" all'interno del testo di quota "Forzato"
;------------------------------------------------------------------------
;
; Se all'uscita di questa sub. il flag  = a nil significa che il testo
; ha comunque la stringa "<>" all'interno: non verr sottolineato
;
(defun PARTI (txt / lungtxt indlung lungtxt trov)
  
  (setq flag T)				; inizializza il flag (var. globale)
  (setq lungtxt (strlen txt))		; Lunghezza parola trovata
  (setq indlung (+ (- lungtxt 2) 1))	; Inizializza indice indlung
;
  (while (> indlung 0)
     (setq trov (substr txt indlung 2))	; Cerca par. nella stringa
     (if (= trov "<>")			; Se trova la parola "<>"
       (progn
	 (setq flag nil)		; ... pone il flag a nil
         (setq trov nil)		; Annulla parola
         (setq indlung 0)		; Forza uscita da while
       )
     )
     (setq indlung (- indlung 1))	; Decrementa l'indice
  )
)
;
;-------------------------------------------------------
;	P R O G R A M M A     P R I N C I P A L E	
;-------------------------------------------------------
(defun c:VERIFQTA (/
		   a mlst st olderr	; Variabili gestione errori
		   ent			; Set di selezione entit (vengono filtrate solo le quote)
		   num			; Numero di entit trovate
		   nome			; Nome esadecimale di un'entit
		   indice		; Indice per scorrere le entit una da una
		   lst lst1		; Rispettivam. una lista prima e dopo la modifica
		   txt txt1		; Txt = testo originale - Txt1 = testo modificato
		   flag			; Se diverso da nil il testo viene sottolineato
		   primav		; Flag per far cliccare in una zona vuota: dopo la prima volta diventa nil
		   pt1			; Punto in una zona vuota dello schermo da cui partono le linee
		   pt2			; Punto sulla line di quota modificata
		  )
;
   (graphscr)
;
   (setq olderr *error* *error* b_err)	; Richiama gestore errori
;
   (indati)
;
   (if primav (alert "NON CI SONO QUOTE DA EVIDENZIARE")); Se primav=T non ha trovato quote da evid.
;
   (moder)
;
   (setq olderr *error*)		; Ripristina in caso di errore
   (princ)				; Esce senza nil
)
